<?php

namespace Drupal\recurly_aegir\Processors;

/**
 * Processes new subscriptions.
 */
class SubscriptionNewProcessor extends Processor {

  /**
   * {@inheritdoc}
   *
   * Process new subscriptions.
   */
  public function process() {
    if (!$this->subscription->isActive()) {
      return $this->failAndLogMessage("Inactive subscription %uuid created by user %user. Skipping site creation.");
    }

    if ($this->subscription->getSite($this->getAccountCode(), FALSE)) {
      return $this->failAndLogMessage("A site has already been created for user %user with subscription %uuid. Skipping.");
    }

    $user_id = $this->subscription->getUserId($this->getAccountCode(), TRUE);
    $this->subscription->createSite($user_id);

    $this->result = TRUE;
    return $this;
  }

}
