<?php

namespace Drupal\recurly_aegir\Processors;

use Drupal\recurly_aegir\Provisioners\SiteQuotaProvisioner;

/**
 * Processes updated subscriptions.
 */
class SubscriptionUpdatedProcessor extends Processor {

  /**
   * {@inheritdoc}
   *
   * Process subscription updates.
   */
  public function process() {
    if (!$this->subscription->isActive()) {
      return $this->failAndLogMessage("Inactive subscription %uuid for user %user is not longer active. Skipping update processing.");
    }

    if (!$site = $this->subscription->getSite($this->getAccountCode())) {
      return $this->failAndLogMessage("Could not find site associated with subscription %uuid for user %user. Skipping update processing.");
    }

    SiteQuotaProvisioner::setQuotas($site, $this->subscription->getPlanCode(), $this->subscription->getAddons());
    $site->save();

    $this->result = TRUE;
    return $this;
  }

}
